#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>


#define MAXPAT    64
#define MAXVALDOM 256
//#define NUMBERVALDOM 6
typedef struct _VALDOM_ {
	int len;
	unsigned char pattern[MAXPAT];
} VALDOM;
extern struct _SETVALDOM_ {
	int maxvaldom;
	VALDOM valdom[MAXVALDOM];
} valdomset;


int valdom_init(void) {
#define MAXREGSZ 128
#define MAXREGSZI MAXREGSZ-1
	FILE *fp;
	int nreg,lenv,i,k,maxreg=0;
	unsigned char reg[MAXREGSZ]={MAXREGSZ*0};
	char arq[MAXREGSZ]="valdom.db"; //{128*0};
	char *env;

	env=env_get("VALDOM");
	if (env != NULL ) {
		lenv=strlen(env);
		if ( lenv < MAXREGSZ )
		{
			byte_zero(arq,MAXREGSZ);
			byte_copy(arq,(unsigned int) lenv,env);
		} else {
			printf("Size name of VALDOM is greater than 128 bytes\n");
			exit(1);
		}
	} else {
		printf("Using default database: valdom.db\n");
	}
	fp = fopen(arq,"r");
	if (fp == NULL) {
		printf("File pointed by VALDOM does not exist!\n");
		exit(0);
	}
	/* Cleaning up valdomset structure */
	byte_zero(&valdomset,sizeof(valdomset));

	/*
	Reading valid domains from database.
	We can read only 127 bytes to allow a valid counter
	*/
	while (fgets((char *)&reg[0],MAXREGSZI,fp) != NULL) {

		/* Checking valid domain counter*/
		if (maxreg == MAXVALDOM) {
			printf("Number of valid domains exceeded %d! Aborting...\n",MAXVALDOM);
			exit(1);
		}

		/* Computing the number of bytes of input domain*/
		nreg=strlen(reg);
		if (nreg == MAXREGSZI) {
			printf("Invalid domain at line %d of file %s\n",maxreg,arq);
			exit(1);
		}
		/* Computing the last byte of reg because
		fgets insert a newline at end of stream.*/
		nreg--;

		/* Cleaning up the newline */ 
		reg[nreg]=0;
		nreg--;

		/* reseting the counter */
		k=0;

		/* Now we are seeking by '.' (dot) and replacing
		 it by number of bytes of sequence. We seek the dot
		 from end char to initial byte. */
		for (i=nreg; i> -1; i--) {
			if (reg[i] != '.' ) k++; 
			else {
				if (k > 255) {
					printf("Invalid domain name at line %d of file %s\n",
						maxreg,arq);
					exit(1);
				}
				/* Replacing dot by number of bytes*/
				reg[i]=(char) k;

				/* Reseting the counter*/
				k=0;
			}
		}

		/*
			Loading the valdomset structure with domain
			under DNS format.
		*/
		nreg++;
		byte_copy(valdomset.valdom[maxreg].pattern,nreg,reg);
		valdomset.valdom[maxreg].len=nreg;

		/* Cleaning up reg*/
		byte_zero(reg,MAXREGSZ);
		/* Updating the number of valid domains*/
		maxreg++;
	}
	valdomset.maxvaldom = maxreg;
	return 0;
}
